//+------------------------------------------------------------------+
//|                                                 Correlations.mq4 |
//|                                                 Bogdan Caramalac |
//|                                     mailto:fxeconomist@yahoo.com |
//+------------------------------------------------------------------+
#property copyright "Bogdan Caramalac"
#property link      "mailto:fxeconomist@yahoo.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Yellow
//---- input parameters
extern string    Contract1="USDCHF";
extern bool      RevContract1=true;
extern string    Contract2="GBPUSD";
extern bool      RevContract2=false;
extern datetime  StartupTime=D'2001.01.03 12:00';
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
double CrtStartupClose,Ctr1StartupClose,Ctr2StartupClose;
int frombar;

int init()
  {
  int ib0,ib1,ib2;
  ib0=iBarShift(Symbol(),Period(),StartupTime);
  ib1=iBarShift(Contract1,Period(),StartupTime);
  ib2=iBarShift(Contract2,Period(),StartupTime);
  frombar=MathRound(MathMin(MathMin(ib0,ib1),ib2));
  CrtStartupClose=iClose(Symbol(),Period(),ib0);
  Ctr1StartupClose=iClose(Contract1,Period(),ib1);
  Ctr2StartupClose=iClose(Contract2,Period(),ib2);
//---- indicators 
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double Ctr1Now,Ctr2Now;
   int pos;
   int    counted_bars=IndicatorCounted();
   if (counted_bars<0) return(-1);
   //---- last counted bar will be recounted
   if (counted_bars>0) counted_bars--;
   pos=Bars-counted_bars;
   //---- main calculation loop      
   while(pos>=0)
   {       
   if (pos<frombar)
      {
      if (RevContract1==False)
        { Ctr1Now=CrtStartupClose+iClose(Contract1,Period(),pos)-Ctr1StartupClose; }
      else
        { Ctr1Now=CrtStartupClose-iClose(Contract1,Period(),pos)+Ctr1StartupClose; }
      if (RevContract2==False)
        { Ctr2Now=CrtStartupClose+iClose(Contract2,Period(),pos)-Ctr2StartupClose; }
      else
        { Ctr2Now=CrtStartupClose-iClose(Contract2,Period(),pos)+Ctr2StartupClose; }
      ExtMapBuffer1[pos]= Ctr1Now;         
      ExtMapBuffer2[pos]= Ctr2Now;
      }
   pos--;
   }//while  
   return(0);
  }
//+------------------------------------------------------------------+